#ifndef HW_1_FUNCTION_H
#define HW_1_FUNCTION_H

#include <iostream>
#include <fstream>
#include <algorithm>
#include <iterator>
#include <vector>
#include <deque>
#include <list>
#include <string>
#include <sstream>

void createData_stream() {
    std::ofstream fout("Data.txt");
    for (int i = 0; i < 99; ++i)
        fout << rand() % 101 - 50 << " ";
    fout << std::endl;
}


template<typename type>
void createData_generate() {
    std::vector<type> myvec(100);
    std::generate(myvec.begin(), myvec.end(), []() { return rand() % 101-50; });
    std::ofstream fout("Data.txt");
    std::ostream_iterator<type> fout_it(fout, " ");
    std::copy(myvec.begin(), myvec.end(), fout_it);
}

template<typename _Container>
_Container loadData_stream(const std::string& filename) {
    _Container m_container;
    using value_type = typename _Container::value_type;

    std::ifstream fin(filename);
    if (!fin) {
        std::cerr << "File cannot be opened" << std::endl;
        // ЧТО ТУТ ПРОИСХОДИТ?
        exit;
    }

    std::string line;
    while (std::getline(fin, line, ' ')) {
        // ЧИТАЙ НАПРЯМУЮ ИЗ ФАЙЛА
        std::istringstream iss(line);
        value_type elem;
        if (!(iss >> elem))
            break;
        m_container.push_back(elem);
    }
    std::cout<<"loadData_stream:\n";
    for (const auto& elem : m_container)
        std::cout << elem << " ";
    return m_container;
}

template<typename _Container>
_Container loadData_copy(const std::string& filename) {
    using value_type = typename _Container::value_type;

    _Container m_container(100);
    std::ifstream fin(filename);
    if (!fin) {
        std::cerr << "File cannot be opened" << std::endl;
        // ЧТО ТУТ ПРОИСХОДИТ?
        exit;
    }
    else {
        std::copy(std::istream_iterator<value_type>(fin), std::istream_iterator<value_type>(), m_container.begin());
        std::cout<<"\nloadData_copy:\n";
        for (const auto& elem : m_container)
            std::cout << elem << " ";
        return m_container;
    }
}

//----------------------------------------- 13 -----------------------------------------
template<typename _Container>
_Container modify_template(const _Container& cont)
{
    _Container res;
    using value_type = typename _Container::value_type;
    value_type min = *(std::min_element(cont.begin(), cont.end()));
    for (auto& elem : cont) {
        if (elem > 0)
            res.push_back(min*min);
        else
            res.push_back(elem);
    }
    std::cout<<"\nmodify_template:\n";
    for (const auto& elem : res)
        std::cout << elem << " ";
    return res;
}

template<typename _Input_Iter, typename _Des_Iter>
void modify_iter(const _Input_Iter iter_beg, const _Input_Iter iter_end, _Des_Iter des_iter) {
    using value_type = typename _Input_Iter::value_type;
    value_type min = *(std::min_element(iter_beg,iter_end));
    auto tmp_iter = des_iter;
    for (auto it = iter_beg; it != iter_end; ++it) {
        if (*it > 0)
        {
            *(tmp_iter++) = min*min;
        }
        else
            *(tmp_iter++) = *it;
    }
}

template<typename _Container>
void modify_for_each(_Container& m_cont) {
    using value_type = typename _Container::value_type;
    value_type min = *(std::min_element(m_cont.begin(),m_cont.end()));
    // min ПЕРЕДАВАЙ ПО ЗНАЧЕНИЮ, ВЕДЬ НЕ ИЗМЕНЯЕТСЯ ВНУТРИ ЛЯМБДЫ
    std::for_each(m_cont.begin(), m_cont.end(), [&min](value_type& elem) {
        if(elem>0)
            elem = min*min;
    });
}
template<typename _Container>
void modify_transform(const std::string& input_fname, const std::string& output_fname) {
    using value_type = typename _Container::value_type;
    std::ifstream fin_copy(input_fname);
    std::ifstream fin_trans(input_fname);
    std::ofstream fout(output_fname, std::ios::app);
    if (!fin_copy) {
        std::cerr << "File cannot be opened" << std::endl;
    }
    else {
        _Container m_cont(100);
        std::copy(std::istream_iterator<value_type>(fin_copy), std::istream_iterator<value_type>(), m_cont.begin());
        int min = *(std::min_element(m_cont.begin(),m_cont.end()));
        std::transform(std::istream_iterator<value_type>(fin_trans), std::istream_iterator<value_type>(), std::ostream_iterator<value_type>(fout, " "),
                       // ПО ЗНАЧЕНИЮ ПЕРЕДАВАЙ
                       [&min](int elem) {
                           if(elem>0)
                               return (min*min);
                           return elem;
                       });
    }
}

template <typename _Container>
void outputResult_stream(const std::string& filename, const _Container& cont){
    std::ofstream fout(filename, std::ios::app);
    for (const auto& elem : cont)
        fout << elem << "\t";
    fout << std::endl;
}

template <typename _Container>
void outputResult_copy(const std::string& filename, const _Container& cont) {
    using m_type = typename _Container::value_type;
    std::ofstream fout(filename, std::ios::app);
    std::copy(cont.begin(), cont.end(), std::ostream_iterator<m_type>(fout, "\t"));
    fout << std::endl;
}

// ЧТО ЗА ПАРАМЕТ ПОСЛЕ ДИРЕКТИВЫ endif?
#endif HW_1_FUNCTION_H
