#ifndef HW1_2_TOY_H
#define HW1_2_TOY_H
#include "iostream"
#include "map"
#include <fstream>
#include <iomanip>
#include <algorithm>


struct Toy {
    char m_name[128];
    char m_date[128];
    char m_provider[128];
    double m_code;
    char m_type[128];
    double m_price;
    char m_range[128];
    int m_amount;

    Toy() = default;
    Toy(const char *, const char *, const char *, double , const char *, double ,const char *, int );

    friend std::istream& operator>>(std::istream& p_in, Toy& toy);
    friend std::ostream& operator<<(std::ostream& p_out, const Toy& toy);

};

class File
{
public:
    using map_array = std::map<int, Toy>;

    explicit File(const std::string&);

    void create_file();
    void add_to_file(const std::initializer_list<Toy>&);
    void delete_from_file(int);
    void replace_in_file(int, const Toy&);
    void transform_to_text();
    void search_by_date(const std::string&);
    void search_by_provider(const std::string&);
    void search_by_price(double);
private:
    std::string m_fname;
    bool first_create = 0;
    map_array m_arr;

    void get_data();
};

#endif //HW1_2_TOY_H